#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <shlwapi.h>
#include "testdll.h"
#include "..\apihijack.h"
#include <stdio.h>

// Text buffer for sprintf
char Work[256];

HINSTANCE hDLL;
bool nomap;

// Function pointer types.
typedef HANDLE (WINAPI *NewCreateFileA_Type)(LPCSTR lpFileName, DWORD  dwDesiredAccess, DWORD  dwShareMode, LPSECURITY_ATTRIBUTES  lpSecurityAttributes, DWORD  dwCreationDistribution, DWORD  dwFlagsAndAttributes, HANDLE  hTemplateFile);

// Function prototypes.
HANDLE WINAPI NewCreateFileA(LPCSTR lpFileName, DWORD dwDesiredAccess, DWORD  dwShareMode, LPSECURITY_ATTRIBUTES  lpSecurityAttributes, DWORD  dwCreationDistribution, DWORD  dwFlagsAndAttributes, HANDLE  hTemplateFile);

HANDLE HandleCommand(char *command); // in chandler.cpp

// Hook structure.
enum
{
    D3DFN_CreateFileA = 0
};

SDLLHook D3DHook = 
{
    "KERNEL32.DLL",
    false, NULL,		// Default hook disabled, NULL function pointer.
    {
        {"CreateFileA", NewCreateFileA},
        {NULL, NULL}
    }
};

// Output debug string
void DebugMessage(char *first, ...)
{
	va_list     argptr;
	char        Message[512];

	va_start (argptr,first);
	vsprintf (Message,first,argptr);
	va_end   (argptr);

	OutputDebugString(Message);  
}

// Hook function.
HANDLE WINAPI NewCreateFileA(LPCSTR lpFileName, DWORD dwDesiredAccess, DWORD  dwShareMode, LPSECURITY_ATTRIBUTES  lpSecurityAttributes, DWORD  dwCreationDistribution, DWORD  dwFlagsAndAttributes, HANDLE  hTemplateFile) {
	//DebugMessage("fwatch: NewCreateFileA %s %d %d %d", lpFileName, dwFlagsAndAttributes, dwShareMode, dwCreationDistribution);

	int len = strlen(lpFileName);
	if(!strncmp("scripts\\:", lpFileName, 9)) {
		// This filename is meant for us
		if(dwFlagsAndAttributes == 128) {
			// Script is being opened for execution

			char *command = (char*) lpFileName+9;
			//DebugMessage("fwatch: command: %s", command);

			// Call HandleCommand, and return returned file handle to OFP
			return HandleCommand(command);
		} else {
			// Just a check if the file is there, return something for OFP to read
			HANDLE rp, wp;
			CreatePipe(&rp, &wp, NULL, 256);

			DWORD foo;
			char str[] = "shei masa fum de ma";
			WriteFile(wp, str, strlen(str), &foo, NULL);
			CloseHandle(wp);
			return rp;
		}
	} else if(len > 16) {
		if(!strcmp("fwatch_check.sqf", lpFileName+(len-16))) {
			// Any access attempt to a file named fwatch_check.sqf will be redirected to fwatch/data/true.sqf

			DebugMessage("fwatch: presence check");
			strcpy((char*) lpFileName, "fwatch\\data\\true.sqf");

		}
	} 

	// Call real CreateFileA
    NewCreateFileA_Type OldFn = 
        (NewCreateFileA_Type)D3DHook.Functions[D3DFN_CreateFileA].OrigFn;

    return OldFn(lpFileName, dwDesiredAccess, dwShareMode, lpSecurityAttributes, dwCreationDistribution, dwFlagsAndAttributes, hTemplateFile);
}

// CBT Hook-style injection.
BOOL APIENTRY DllMain( HINSTANCE hModule, DWORD fdwReason, LPVOID lpReserved )
{
    if ( fdwReason == DLL_PROCESS_ATTACH )  // When initializing....
    {
        hDLL = hModule;

        // We don't need thread notifications for what we're doing.  Thus, get
        // rid of them, thereby eliminating some of the overhead of this DLL
        DisableThreadLibraryCalls( hModule );

        // Only hook the APIs if this is the ofp proess.
        GetModuleFileName( GetModuleHandle( NULL ), Work, sizeof(Work) );
        PathStripPath( Work );

		DebugMessage("fwatch: checking process %s", Work);
		
        if(!stricmp(Work, "flashpointresistance.exe") || !stricmp(Work, "flashpointbeta.exe") || !stricmp(Work, "operationflashpoint.exe") || !stricmp(Work, "ofpr_server.exe")) {
            HookAPICalls(&D3DHook);

			// Is nomap used?
			// Crappy method to check for it...
			int l = strlen(GetCommandLine());
			char *cl = new char[l+1];
			strcpy(cl, GetCommandLine());
			for(int x=0;x < l;x++) 
				cl[x] = tolower(cl[x]);
			nomap = strstr(cl,"-nomap") != 0;
			delete[] cl;

			if(!nomap)
				DebugMessage("fwatch: Warning! -nomap not used, cannot use pipes for data transfer.");
		}

        if(!stricmp(Work, "fwatch.exe")) {
			HookAPICalls(&D3DHook);
		}

    }

    return TRUE;
}

// This segment must be defined as SHARED in the .DEF
#pragma data_seg (".HookSection")		
// Shared instance for all processes.
HHOOK hHook = NULL;	
#pragma data_seg ()

TESTDLL_API LRESULT CALLBACK HookProc(int nCode, WPARAM wParam, LPARAM lParam) 
{
    return CallNextHookEx( hHook, nCode, wParam, lParam); 
}

TESTDLL_API void InstallHook()
{
    hHook = SetWindowsHookEx(WH_CBT, HookProc, hDLL, 0); 
    OutputDebugString( "fwatch: hook installed.\n" );
}

TESTDLL_API void RemoveHook()
{
    UnhookWindowsHookEx(hHook);
	OutputDebugString( "fwatch: hook removed.\n" );
}
