#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <stdio.h>
#include "..\testdll\testdll.h"

bool runOfp(LPSTR lpCmdLine);
bool TestHook(void);

char reqfiles[][256] = {
	"fwatch/data/wget.exe",
	"fwatch/data/true.sqf",
	"fwatch/data/fwatch_check.sqf",	
	NULL,
};

int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow)
{
	bool nolaunch = false;

	// -nolaunch?
	if(!strncmp(lpCmdLine, "-nolaunch", 9)) 
		nolaunch = true;

	// Check that all required files are in place
	int x = 0;
	char *f;
	while((f = reqfiles[x])[0] != NULL) {
		FILE *h = fopen(f, "rb");
		if(h)
			fclose(h);
		else {
			char foo[512];
			sprintf(foo, "File %s not found!\nEnsure that Fwatch is properly installed.", f);
			MessageBox(NULL, foo, "fwatch error", MB_OK|MB_ICONSTOP);
			exit(0);
		}		
		x++;
	} 

	// Install hook
    InstallHook();

	// Make sure the hooks work	
	int res;
	do {
		res = IDOK;
		if(!TestHook()) {
			Sleep(500); // Wait a while and automatically retry once
			if(!TestHook()) {
				res = MessageBox(NULL, "Self test failed, Fwatch hooks do not appear to be working.\n", "fwatch error", MB_ABORTRETRYIGNORE|MB_ICONSTOP);			
				if(res == IDABORT)
					exit(0);
			}
		}
	} while(res == IDRETRY);

	if(!nolaunch) {
		// Attempt to run OFP
		if(!runOfp(lpCmdLine))
			MessageBox(NULL, "Could not run FlashpointResistance.exe!\n\nEnsure fwatch.exe is located in your OFP install directory,\nor run fwatch with -nolaunch parameter and run OFP manually.", "fwatch error", MB_OK|MB_ICONSTOP);
	} else {
		// Just sit and wait here
	    MessageBox( NULL, "Hook installed, waiting for FlashpointResistance.exe or OFPR_Server.exe\nPress OK to remove hook and exit.", "fwatch", MB_OK|MB_ICONINFORMATION );
	}

	// Remove hook
    RemoveHook();
    return 0;
}


bool runOfp(LPSTR lpCmdLine) {
	PROCESS_INFORMATION pi;
    STARTUPINFO si; 
	DWORD dwExitCode = STILL_ACTIVE;

    memset(&si,0,sizeof(si));
    si.cb= sizeof(si);

	// Duh, need an extra space in the beginning of the command line for it to work
	char *cmdLine = new char[strlen(lpCmdLine)+2];
	cmdLine[0] = ' ';
	strcpy(cmdLine+1, lpCmdLine);

    if(!CreateProcess("FlashpointResistance.exe", cmdLine, NULL, NULL, false, 0, NULL,NULL,&si,&pi))
        return false;

	delete[] cmdLine;

	// Wait until the process has terminated
	while(dwExitCode == STILL_ACTIVE) {
		GetExitCodeProcess(pi.hProcess, &dwExitCode);
		Sleep(1000);
	}

	return true;
}


bool TestHook(void) {
	HANDLE filu = CreateFile("scripts\\:info version", GENERIC_READ, 0, NULL, OPEN_EXISTING, 128, NULL);
	if(filu == INVALID_HANDLE_VALUE)
		return false;
	
	CloseHandle(filu);
	return true;
}